var argsSep = "@@args";
getMapFromStr = function(mappingStr) {
    var map = {
        put : function(key, val) {
            this[key] = val;
            if (!this.keyList)
                this.keyList = [];
            if (!this.hasKey(key))
                this.keyList[this.keyList.length] = key;
        },

        putTuple : function(key, val1, val2) {
            var val = val1 + argsSep + val2;
            this.put(key, val);
        },
        get : function(key) {
            return this[key];
        },
        getCommandValue : function(key) {
            var str = this.get(key);
            return str.split(argsSep)[0];
        },
        getArgValue : function(key) {
            var str = this.get(key);
            return str.split(argsSep)[1];
        },
        hasKey : function(key) {
            for ( var i = 0; i < this.keyList.length; i++) {
                if (this.keyList[i] == key)
                    return true;
            }
            return false;
        },
        getKeys : function() {
            if (!this.keyList)
                this.keyList = [];
            return this.keyList;
        },
        removeKey : function(key) {
            if (!this.hasKey(key))
                return;
            this[key] = null;
            var nKeyList = [];
            for ( var i = 0; i < this.keyList.length; i++) {
                if (this.keyList[i] != key) {
                    nKeyList.push(this.keyList[i]);
                    // nKeyList[nKeyList.length]=this.keyList[i];
    }
}
this.keyList = nKeyList;
}
    }
    map.keyList = [];
    var mappings = mappingStr.split(";");
    for ( var i = 0; i < mappings.length; i++) {
        var mappingItem = mappings[i];
        var entries = mappingItem.split(":");
        if (entries.length == 2) {
            var key = unescape(mappingItem.split(":")[0]);
            var val = unescape(mappingItem.split(":")[1]);
            map.put(key, val);
        }
    }
    return map;
}

getStrFromMap = function(map) {
    var str = "";
    var keys = map.getKeys();
    for (i = 0; i < keys.length; i++) {
        var k = escape(keys[i]);
        var v = escape(map.get(k));
        str = str + k + ":" + v + ";";
    }
    return str;
}
